# coding: utf-8

"""
    OpenAI API

    The OpenAI REST API. Please see https://platform.openai.com/docs/api-reference for more details.

    The version of the OpenAPI document: 2.0.0
    Contact: blah+oapicf@cliffano.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapiopenai.models.fine_tuning_job_checkpoint import FineTuningJobCheckpoint
from typing import Optional, Set
from typing_extensions import Self

class ListFineTuningJobCheckpointsResponse(BaseModel):
    """
    ListFineTuningJobCheckpointsResponse
    """ # noqa: E501
    data: List[FineTuningJobCheckpoint]
    object: StrictStr
    first_id: Optional[StrictStr] = None
    last_id: Optional[StrictStr] = None
    has_more: StrictBool
    __properties: ClassVar[List[str]] = ["data", "object", "first_id", "last_id", "has_more"]

    @field_validator('object')
    def object_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['list']):
            raise ValueError("must be one of enum values ('list')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListFineTuningJobCheckpointsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in data (list)
        _items = []
        if self.data:
            for _item in self.data:
                if _item:
                    _items.append(_item.to_dict())
            _dict['data'] = _items
        # set to None if first_id (nullable) is None
        # and model_fields_set contains the field
        if self.first_id is None and "first_id" in self.model_fields_set:
            _dict['first_id'] = None

        # set to None if last_id (nullable) is None
        # and model_fields_set contains the field
        if self.last_id is None and "last_id" in self.model_fields_set:
            _dict['last_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListFineTuningJobCheckpointsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "data": [FineTuningJobCheckpoint.from_dict(_item) for _item in obj["data"]] if obj.get("data") is not None else None,
            "object": obj.get("object"),
            "first_id": obj.get("first_id"),
            "last_id": obj.get("last_id"),
            "has_more": obj.get("has_more")
        })
        return _obj


